# First we pull in the standard API hooks.
require 'sketchup.rb'

# Show the Ruby Console at startup so we can
# see any programming errors we may make.
Sketchup.send_action "showRubyPanel:"

# Add a menu item to launch our plugin.
UI.menu("PlugIns").add_item("Build modules") {

  # Call our new method.
  draw_geometry

  view = Sketchup.active_model.active_view
  new_view = view.zoom_extents
}

def draw_geometry
  # Convert factor for mm per inch.
  mmperinch = 0.0254

  # Get handles to our model and the Entities collection it contains.
  model = Sketchup.active_model
  entities = model.entities

  # Clear the workspace
  entities.clear!
  
  File.open("C:/SBSD/input.txt") do |file|

    while content = file.gets
	 
		# This line ensures that dots are used for decimals
		content.gsub!(',','.')

		parts = content.split

		filename = parts[6]

		posx = (parts[0].to_f/mmperinch)
		posy = (parts[1].to_f/mmperinch)
		posz = (parts[2].to_f/mmperinch)

		scalex = parts[3].to_f
		scaley = parts[4].to_f
		scalez = parts[5].to_f

		parts_def = Sketchup.active_model.definitions.load("C:/SBSD/modules/#{filename}.skp")

		parts_location = Geom::Point3d.new posx,posy,posz
		transform = Geom::Transformation.new parts_location
		entities = Sketchup.active_model.active_entities
		instance = entities.add_instance parts_def, transform
		
		t = Geom::Transformation.scaling parts_location, scalex, scaley, scalez
		status = instance.transform! t
    end
  end
end